VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Sound.mul Read by Fallout"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4515
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4515
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtUoPathIdx 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      Height          =   285
      Left            =   1440
      TabIndex        =   6
      Text            =   "c:\program files\ultima online\soundidx.mul"
      Top             =   2040
      Width           =   3015
   End
   Begin VB.CommandButton cmdGet 
      Caption         =   "Get List Of Sound"
      Height          =   375
      Left            =   1440
      TabIndex        =   5
      Top             =   1080
      Width           =   3015
   End
   Begin VB.TextBox txtUoPath 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      Height          =   285
      Left            =   1440
      TabIndex        =   4
      Text            =   "c:\program files\ultima online\sound.mul"
      Top             =   1560
      Width           =   3015
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save Sound In File"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Top             =   600
      Width           =   3015
   End
   Begin VB.TextBox txtFileName 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      Height          =   285
      Left            =   1440
      TabIndex        =   1
      Top             =   240
      Width           =   3015
   End
   Begin VB.ListBox lstID 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      Height          =   3150
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Sound File Name :"
      Height          =   195
      Left            =   1440
      TabIndex        =   2
      Top             =   0
      Width           =   1305
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Crafted by Fallout                                                                                                                                                             '
' This file consist Sound in *.wav format                                                                                                                                        '
' PCM 22.050 kHz, 16-Bit Mono                                                                                                                                                    '
' Chunk's format :                                                                                                                                                               '
' "RIFF"<size of waveData() + size of "WAVEfmt " + size of "data" 4byte>                                                                                                         '
' "WAVEfmt "<size of "WAVEfmt " - 12 4 byte;2 byte TAG;2 byte number of chanel (1 - mono 2 - stereo);Rate - 22050 4 byte;Bit/Sec Rate*2 4byte;Align - 2 2 byte;Bits - 16 2 byte> '
' "data"<size of waveData() array as 4 byte value>                                                                                                                               '

Dim sOffset As Long
Dim sLength As Long
Dim sExtra As Long
Dim FileName(0 To 19) As Byte
Dim Header(0 To 19) As Byte
Dim waveData() As Byte
Dim i As Long

' RIFF Chunk '
Private Type tRIFF
    RIFF(0 To 3) As Byte
    DataLen As Long
End Type
' WAVEfmt Chunk '
Private Type tWAVEfmt
    WAVEfmt(0 To 7) As Byte
    WAVEfmtLen As Long
    Tag As Integer
    Chanel As Integer
    Rate As Long
    BitSec(0 To 1) As Integer
    BlockSize As Integer
    Bits As Integer
End Type
' DATA Chunk '
Private Type tDATA
    DATA(0 To 3) As Byte
    WaveLen As Long
End Type

Dim riffCHUNK As tRIFF
Dim waveCHUNK As tWAVEfmt
Dim dataCHUNK As tDATA
Dim fileNum As Integer
Private Sub decode_sound(RecordNum As Integer)
    fileNum = FreeFile()
    Open txtUoPathIdx.Text For Binary Access Read As fileNum
    Get fileNum, RecordNum * 12 + 1, sOffset
    Get fileNum, Seek(fileNum), sLength
    Get fileNum, Seek(fileNum), sExtra
    Close fileNum
    fileNum = FreeFile()
    Open txtUoPath.Text For Binary Access Read As fileNum
    Get fileNum, sOffset + 1, FileName()
    Get fileNum, Seek(fileNum), Header()
    ReDim waveData(0 To sLength - 40 - 1)
    Get fileNum, Seek(fileNum), waveData()
    txtFileName = StrConv(FileName(), vbUnicode)
    Close fileNum
End Sub

Private Sub cmdGet_Click()
    i = 0
    fileNum = FreeFile()
    Open txtUoPathIdx.Text For Binary Access Read As fileNum
    Do Until EOF(fileNum)
        Get fileNum, i * 12 + 1, sOffset
        If Not sOffset = -1 Then
            lstID.AddItem i
        End If
        i = i + 1
    Loop
    Close fileNum
End Sub

Private Sub cmdSave_Click()
    ' Compile chunk's '
    With riffCHUNK                 ' RIFF '
        .RIFF(0) = &H52
        .RIFF(1) = &H49
        .RIFF(2) = &H46
        .RIFF(3) = &H46
        .DataLen = (sLength - 40) + Len(waveCHUNK) + Len(dataCHUNK)
    End With
    With waveCHUNK                 ' WAVE '
        .WAVEfmt(0) = &H57
        .WAVEfmt(1) = &H41
        .WAVEfmt(2) = &H56
        .WAVEfmt(3) = &H45
        .WAVEfmt(4) = &H66
        .WAVEfmt(5) = &H6D
        .WAVEfmt(6) = &H74
        .WAVEfmt(7) = &H20
        .WAVEfmtLen = Len(waveCHUNK) - 12
        .Tag = &H1
        .Chanel = &H1
        .Rate = &H5622
        .BitSec(0) = &HAC44
        .BlockSize = 2
        .Bits = 16
    End With
    With dataCHUNK                 ' data '
        .DATA(0) = &H64
        .DATA(1) = &H61
        .DATA(2) = &H74
        .DATA(3) = &H61
        .WaveLen = sLength - 40
    End With
    ' Save Compiled Sound On Disk '
    fileNum = FreeFile()
    Open txtFileName For Binary As fileNum
    Put fileNum, Seek(fileNum), riffCHUNK
    Put fileNum, Seek(fileNum), waveCHUNK
    Put fileNum, Seek(fileNum), dataCHUNK
    Put fileNum, Seek(fileNum), waveData()
    Close fileNum
    MsgBox "Sound Save Done ! Injoi ! (Fallout - ICQ: 166321817; Email: roman3k@mail.ru; WEB: http://mudator.by.ru)"
End Sub

Private Sub lstID_Click()
    cmdSave.Enabled = True
    decode_sound (CInt(lstID.Text))
End Sub
